#<profile4xi profile = "31"/>
#<program4xi program = "walk2gen4tar.py">
#<abstract4xi abstract = "walks through spefied main folders generating config for fpm (fast process management) as equired"/>
#<refer4xi reference = "Studio4Xi"/>
#<note4xi note = "set ack2debug, KB4Tailoring for test; run walk2parse4app.py for one; verify at https://html5.validator.nu/"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'walk2gen4tar' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os,sys,string
import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Studio4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI 
#"
#/>
# -------------------------------------------------------------------------------------------------
# Multiprocessing4xi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from actor2a4xi import Actor2a4Xi                                                                                  
from actor2b4xi import Actor2b4Xi                                                                                   
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi

from pickle4xi import pickle4xi                                                                                   
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi 
from pipe4xi import Pipe4Xi   
from print4xi import print4xi
from print4xi import Print4Xi      # from multiprocessing4xi 
from process4xi import Process4Xi
from queue4xi import Queue4Xi
from time4xi import time4xi

from walk2parse4app import walk2parse4app

from xml_trace_sense4xi import xml_trace_sense4xi                                                                   
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# Globals                            
# -------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global ack2debug
global ack2title

global domain2xi
global folder2xi
global portal2xi 

global count2skipped 
global count2total
global file2output

global index2app4yo

global index2head
global index2brand
global index2net4biz
global index2pod4biz
global index2copter4biz
global index2net4pat
global index2pod4pat
global index2copter4pat
global index2net4mil
global index2pod4mil
global index2copter4mil
global index2base4biz
global index2base4pat
global index2base4mil

global index2sensor4biz
global index2sensor4pat
global index2sensor4mil

global index2rd4biz
global index2rd4pat
global index2rd4mil

global index2prd4biz
global index2prd4pat
global index2prd4mil

global index2lambdamobi4biz
global index2lambdamobi4pat
global index2lambdamobi4mil

global index2alphamobi4biz
global index2alphamobi4pat
global index2alphamobi4mil

global index2sw4core
global index2scope4xi
global index2studio4xi

global index2waves4yo
global index2cat4yo
global index2ai4yo
global index2auto4yo
global index2space4yo
global index2ocean4yo 
global index2fish4yo
global index2hunt4yo
global index2quantum4yo
global index2science4yo
global index2special4yo
global index2unmanned4yo
global index2wearable4yo

global index2alpha4yo
global index2a4yo
global index2b4yo
global index2c4yo
global index2d4yo
global index2e4yo
global index2f4yo
global index2g4yo
global index2h4yo
global index2i4yo
global index2j4yo
global index2k4yo
global index2l4yo
global index2m4yo
global index2n4yo
global index2o4yo
global index2p4yo
global index2q4yo
global index2r4yo
global index2s4yo
global index2t4yo
global index2u4yo
global index2v4yo
global index2w4yo
global index2x4yo
global index2y4yo
global index2z4yo

global index2contact4yo
global index2cbo4yo
global index2cco4yo
global index2cdo4yo
global index2ceo4yo
global index2cfo4yo
global index2cmo4yo
global index2cpo4yo
global index2cto4yo
global index2sec4yo
global index2venture4yo
global index2legal4yo
global index2endhtml4yo

global kb2app
global kb2dev
global kb2org
global kb2com

global kb2slogan
global kb2portal
global kb2type

global kb2proxy
global kb2contact
global kb2time
global kb2user

global app2config
global port2config
global domain2config

global keys2app
global keys2dev
global keys2org
global keys2com
global keys2slogan
global keys2portal
global keys2proxy
global keys2config
global keys2type
global key2time
global keys2user
                          
global key2app
global key2dev
global key2org
global key2com
global key2slogan
global key2portal
global key2proxy
global key2config
global key2type
global key2time
global key2user

global name2create
global path2write4xi

global PickleKB4Xi
global t2xi 
global trace_object_count
#"
#"/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True   # True / False  
ack2title = False  # False: title in input file is not used to solve domain2xi
                   # True:  domain2xi is soolved using input folder id

count2skipped = 0
count2total   = 0                 
                    
domain2xi = "encrypted_dragonxi"                    
file2output = None

index2app4yo = 0

kb2app     = {}  
kb2dev     = {}
kb2pass    = {}  
kb2org     = {}  
kb2com     = {}
kb2proxy   = {}
kb2contact = {}
kb2slogan  = {}
kb2portal  = {}
kb2type    = {}
kb2time    = {}
kb2user    = {}


keys2app     = kb2app.keys()
keys2dev     = kb2dev.keys()
keys2org     = kb2org.keys()
keys2com     = kb2com.keys()
keys2slogan  = kb2slogan.keys()
keys2portal  = kb2portal.keys()
keys2proxy   = kb2proxy.keys()
key2contact  = kb2contact.keys()
keys2type    = kb2type.keys()
keys2time    = kb2time.keys()
keys2user    = kb2user.keys()


path2write4xi = None
path2write4xi = VersionKB4Xi['output2gen4tar'] 

# JATKA
# -------------------------------------------------------------------------------------------------
# KB2TIME - times for users to triger cronjob
# -------------------------------------------------------------------------------------------------
kb2time = {}

kb2tick4aero = {}
kb2tick4aero [0] = '00 '
kb2tick4aero [1] = '1 '
kb2tick4aero [2] = '* '
kb2tick4aero [3] = '* '
kb2tick4aero [4] = '* '
kb2time['aero'] = kb2tick4aero

kb2tick4antarcticocean = {}
kb2tick4antarcticocean [0] = '30 '
kb2tick4antarcticocean [1] = '1 '
kb2tick4antarcticocean [2] = '* '
kb2tick4antarcticocean [3] = '* '
kb2tick4antarcticocean [4] = '* '
kb2time['antarcticocean'] = kb2tick4antarcticocean

kb2tick4appadmin = {}
kb2tick4appadmin [0] = '00 '
kb2tick4appadmin [1] = '2 '
kb2tick4appadmin [2] = '* '
kb2tick4appadmin [3] = '* '
kb2tick4appadmin [4] = '* '
kb2time['appadmin'] = kb2tick4appadmin 

kb2tick4arcticocean = {}
kb2tick4arcticocean [0] = '30 '
kb2tick4arcticocean [1] = '2 '
kb2tick4arcticocean [2] = '* '
kb2tick4arcticocean [3] = '* '
kb2tick4arcticocean [4] = '* '
kb2time['arcticocean'] = kb2tick4arcticocean

kb2tick4atlanticocean = {}
kb2tick4atlanticocean [0] = '00 '
kb2tick4atlanticocean [1] = '3 '
kb2tick4atlanticocean [2] = '* '
kb2tick4atlanticocean [3] = '* '
kb2tick4atlanticocean [4] = '* '
kb2time['atlanticocean'] = kb2tick4atlanticocean

kb2tick4autonomous = {}
kb2tick4autonomous [0] = '30 '
kb2tick4autonomous [1] = '3 '
kb2tick4autonomous [2] = '* '
kb2tick4autonomous [3] = '* '
kb2tick4autonomous [4] = '* '
kb2time['autonomous'] = kb2tick4autonomous

kb2tick4business = {}
kb2tick4business [0] = '00 '
kb2tick4business [1] = '4 '
kb2tick4business [2] = '* '
kb2tick4business [3] = '* '
kb2tick4business [4] = '* '
kb2time['business'] = kb2tick4business

kb2tick4devadmin = {}
kb2tick4devadmin [0] = '30 '
kb2tick4devadmin [1] = '4 '
kb2tick4devadmin [2] = '* '
kb2tick4devadmin [3] = '* '
kb2tick4devadmin [4] = '* '
kb2time['devadmin'] = kb2tick4devadmin

kb2tick4dragon = {}
kb2tick4dragon [0] = '00 '
kb2tick4dragon [1] = '5 '
kb2tick4dragon [2] = '* '
kb2tick4dragon [3] = '* '
kb2tick4dragon [4] = '* '
kb2time['dragon'] = kb2tick4dragon


kb2tick4indianocean = {}
kb2tick4indianocean [0] = '30 '
kb2tick4indianocean [1] = '5 '
kb2tick4indianocean [2] = '* '
kb2tick4indianocean [3] = '* '
kb2tick4indianocean [4] = '* '
kb2time['indianocean'] = kb2tick4indianocean

kb2tick4intelligence = {}
kb2tick4intelligence [0] = '00 '
kb2tick4intelligence [1] = '6 '
kb2tick4intelligence [2] = '* '
kb2tick4intelligence [3] = '* '
kb2tick4intelligence [4] = '* '
kb2time['intelligence'] = kb2tick4intelligence


kb2tick4pacificocean = {}
kb2tick4pacificocean [0] = '30 '
kb2tick4pacificocean [1] = '6 '
kb2tick4pacificocean [2] = '* '
kb2tick4pacificocean [3] = '* '
kb2tick4pacificocean [4] = '* '
kb2time['pacificocean'] = kb2tick4pacificocean

kb2tick4relax = {}
kb2tick4relax [0] = '00 '
kb2tick4relax [1] = '7 '
kb2tick4relax [2] = '* '
kb2tick4relax [3] = '* '
kb2tick4relax [4] = '* '
kb2time['relax'] = kb2tick4relax

kb2tick4science  = {} 
kb2tick4science [0] = '30 '
kb2tick4science [1] = '7 '
kb2tick4science [2] = '* '
kb2tick4science [3] = '* '
kb2tick4science [4] = '* '
kb2time['science'] = kb2tick4science


kb2tick4southernocean = {}
kb2tick4southernocean [0] = '00 '
kb2tick4southernocean [1] = '8 '
kb2tick4southernocean [2] = '* '
kb2tick4southernocean [3] = '* '
kb2tick4southernocean [4] = '* '
kb2time['southernocean'] = kb2tick4southernocean

kb2tick4theater = {}
kb2tick4theater [0] = '30 '
kb2tick4theater [1] = '8 '
kb2tick4theater [2] = '* '
kb2tick4theater [3] = '* '
kb2tick4theater [4] = '* '
kb2time['theater'] = kb2tick4theater

keys2time = kb2time.keys()

import walk2gen4dev
from walk2gen4dev import kb2slogan
keys2slogan  = kb2slogan.keys()

# 
from walk2gen4dev import kb2portal
keys2portal = kb2portal.keys()

from walk2gen4dev import kb2proxy
keys2proxy = kb2proxy.keys()

from walk2gen4dev import kb2user
keys2user = kb2user.keys()

from walk2gen4dev import kb2type
keys2type = kb2type.keys()  

# -------------------------------------------------------------------------------------------------
#
# -------------------------------------------------------------------------------------------------
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<define4xi definition = "
profile2write = '.html'                      # object types to be written
                                             # '.txt'= text '.py'=Python, '.cpp'=C++, '.hpp'=headers, '.c'=C, 
                                             # '.html', 'xml'

#"
#/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4replace" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4replace():
    global ack2debug
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    if ack2debug is True:
        print("(Step 1A/33) OF SET2TRACE4REPLACE - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
        # STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...)  10:11:46 04/02/20 FLE Daylight Time
        print("(Step 1B/33) OF SET2TRACE4REPLACE - USING T2XI: ", t2xi)
        # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4REPLACE - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    if ack2debug is True:
        print('=' *33)
        print("(Step 33/33) OF SET2TRACE4REPLACE - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
        # COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...)  10:11:46 04/02/20 FLE Daylight Time
        print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4replace" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4replace():
    global ack2debug
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    if ack2debug is True:
        print("(Step 01A/33) of DENY2TRACE4REPLACE: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
        # STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...)  10:11:46 04/02/20 FLE Daylight Time
        print("(Step 01B/33) OF DENY2TRACE4REPLACE - USING T2XI: ", t2xi)
        # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4REPLACE - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4REPLACE - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4REPLACE - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4REPLACE - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4REPLACE *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4REPLACE - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4REPLACE - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    if ack2debug is True:
        print("(Step 033/33) OF SET2TRACE4REPLACE - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi())
        # COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...)  10:11:46 04/02/20 FLE Daylight Time 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global ack2debug
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    if ack2debug is True:
        print("(Step 001A/33) OF TAILOR2TRACE4REPLACE - USING T2XI: ", t2xi)
        # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         # 'Pipe4Xi': 'NACK4TRACE',
         # 'Queue4Xi': 'NACK4TRACE',         
         # 'Process4Xi': 'NACK4TRACE',
         'walk2gen4tar': 'NACK4TRACE' # turns off, no comment on 
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        if ack2debug is True:
            print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
            # walk2gen4tar

    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    if ack2debug is True:
        print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
        # COMPLETED  TAILORING:  10:11:46 04/02/20 FLE Daylight Time

#</function4xi>             

# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "zero2index4app" usage = "zeroes indexes
#">                      
# ----------------------------------------------------------------------------------------------------------    
def zero2index4app():
    global index2app4yo
    
    global index2head
    global index2brand
    global index2net4biz
    global index2pod4biz
    global index2copter4biz
    global index2net4pat
    global index2pod4pat
    global index2copter4pat
    global index2net4mil
    global index2pod4mil
    global index2copter4mil
    global index2base4biz
    global index2base4pat
    global index2base4mil
    
    global index2sensor4biz
    global index2sensor4pat
    global index2sensor4mil
    
    global index2rd4biz
    global index2rd4pat
    global index2rd4mil
    
    global index2prd4biz
    global index2prd4pat
    global index2prd4mil
    
    global index2lambdamobi4biz
    global index2lambdamobi4pat
    global index2lambdamobi4mil
    
    global index2alphamobi4biz
    global index2alphamobi4pat
    global index2alphamobi4mil
    
    global index2sw4core
    global index2scope4xi
    global index2studio4xi
    
    global index2waves4yo
    global index2cat4yo
    global index2ai4yo
    global index2auto4yo
    global index2space4yo
    global index2ocean4yo
    global index2fish4yo
    global index2hunt4yo
    global index2quantum4yo
    global index2science4yo
    global index2special4yo
    global index2unmanned4yo
    global index2wearable4yo
    
    global index2alpha4yo
    global index2a4yo
    global index2b4yo
    global index2c4yo
    global index2d4yo
    global index2e4yo
    global index2f4yo
    global index2g4yo
    global index2h4yo
    global index2i4yo
    global index2j4yo
    global index2k4yo
    global index2l4yo
    global index2m4yo
    global index2n4yo
    global index2o4yo
    global index2p4yo
    global index2q4yo
    global index2r4yo
    global index2s4yo
    global index2t4yo
    global index2u4yo
    global index2v4yo
    global index2w4yo
    global index2x4yo
    global index2y4yo
    global index2z4yo
    
    global index2contact4yo
    global index2cbo4yo
    global index2cco4yo
    global index2cdo4yo
    global index2ceo4yo
    global index2cfo4yo
    global index2cmo4yo
    global index2cpo4yo
    global index2cto4yo
    global index2sec4yo
    global index2venture4yo
    global index2legal4yo
    global index2endhtml4yo
    
    global index2app4yo
    
    global index2head
    global index2brand
    global index2net4biz
    global index2pod4biz
    global index2copter4biz
    global index2net4pat
    global index2pod4pat
    global index2copter4pat
    global index2net4mil
    global index2pod4mil
    global index2copter4mil
    global index2base4biz
    global index2base4pat
    global index2base4mil
    
    global index2sensor4biz
    global index2sensor4pat
    global index2sensor4mil
    
    global index2rd4biz
    global index2rd4pat
    global index2rd4mil
    
    global index2prd4biz
    global index2prd4pat
    global index2prd4mil
    
    global index2lambdamobi4biz
    global index2lambdamobi4pat
    global index2lambdamobi4mil
    
    global index2alphamobi4biz
    global index2alphamobi4pat
    global index2alphamobi4mil
    
    global index2sw4core
    global index2scope4xi
    global index2studio4xi
    
    global index2waves4yo
    global index2cat4yo
    
    index2ai4yo = 0
    index2auto4yo = 0
    index2space4yo = 0
    index2ocean4yo = 0
    index2fish4yo = 0
    index2hunt4yo = 0
    index2quantum4yo = 0
    index2science4yo = 0
    index2special4yo = 0
    index2unmanned4yo = 0
    index2wearable4yo = 0
    index2alpha4yo = 0
    index2a4yo = 0
    index2b4yo = 0
    index2c4yo = 0
    index2d4yo = 0
    index2e4yo = 0
    index2f4yo = 0
    index2g4yo = 0
    index2h4yo = 0
    index2i4yo = 0
    index2j4yo = 0
    index2k4yo = 0
    index2l4yo = 0
    index2m4yo = 0
    index2n4yo = 0
    index2o4yo = 0
    index2p4yo = 0
    index2q4yo = 0
    index2r4yo = 0
    index2s4yo = 0
    index2t4yo = 0
    index2u4yo = 0
    index2v4yo = 0
    index2w4yo = 0
    index2x4yo = 0
    index2y4yo = 0
    index2z4yo = 0
    index2contact4yo = 0
    index2cbo4yo = 0
    index2cco4yo = 0
    index2cdo4yo = 0
    index2ceo4yo = 0
    index2cfo4yo = 0
    index2cmo4yo = 0
    index2cpo4yo = 0
    index2cto4yo = 0
    index2sec4yo = 0
    index2venture4yo = 0
    index2legal4yo = 0
    index2endhtml4yo = 0

#</function4xi>

from walk2gen4dev import set2head4app 
from walk2gen4dev import set2brand4app       
from walk2gen4dev import set2net4biz
from walk2gen4dev import set2pod4biz
from walk2gen4dev import set2copter4biz
from walk2gen4dev import set2net4pat
from walk2gen4dev import set2pod4pat
from walk2gen4dev import set2copter4pat
from walk2gen4dev import set2net4mil
from walk2gen4dev import set2pod4mil
from walk2gen4dev import set2copter4mil
from walk2gen4dev import set2base4biz
from walk2gen4dev import set2base4pat
from walk2gen4dev import set2base4mil
from walk2gen4dev import set2sensor4biz
from walk2gen4dev import set2sensor4pat
from walk2gen4dev import set2sensor4mil
from walk2gen4dev import set2rd4biz
from walk2gen4dev import set2rd4biz
from walk2gen4dev import set2rd4mil
from walk2gen4dev import set2prd4biz
from walk2gen4dev import set2prd4pat
from walk2gen4dev import set2prd4mil
from walk2gen4dev import set2lambdamobi4biz
from walk2gen4dev import set2lambdamobi4pat
from walk2gen4dev import set2lambdamobi4mil
from walk2gen4dev import set2alphamobi4biz
from walk2gen4dev import set2alphamobi4pat
from walk2gen4dev import set2alphamobi4mil 
from walk2gen4dev import set2sw4core
from walk2gen4dev import set2scope4xi
from walk2gen4dev import set2studio4xi
from walk2gen4dev import set2waves4yo
from walk2gen4dev import set2cat4yo
from walk2gen4dev import set2ai4yo
from walk2gen4dev import set2auto4yo
from walk2gen4dev import set2space4yo
from walk2gen4dev import set2ocean4yo
from walk2gen4dev import set2fish4yo
from walk2gen4dev import set2hunt4yo
from walk2gen4dev import set2quantum4yo
from walk2gen4dev import set2science4yo
from walk2gen4dev import set2special4yo
from walk2gen4dev import set2unmanned4yo
from walk2gen4dev import set2wearable4yo
from walk2gen4dev import set2alpha4yo
from walk2gen4dev import set2a4yo
from walk2gen4dev import set2b4yo
from walk2gen4dev import set2c4yo
from walk2gen4dev import set2d4yo
from walk2gen4dev import set2e4yo
from walk2gen4dev import set2f4yo
from walk2gen4dev import set2g4yo
from walk2gen4dev import set2h4yo
from walk2gen4dev import set2i4yo
from walk2gen4dev import set2j4yo
from walk2gen4dev import set2k4yo
from walk2gen4dev import set2l4yo
from walk2gen4dev import set2m4yo
from walk2gen4dev import set2n4yo
from walk2gen4dev import set2o4yo
from walk2gen4dev import set2p4yo
from walk2gen4dev import set2q4yo
from walk2gen4dev import set2r4yo
from walk2gen4dev import set2s4yo
from walk2gen4dev import set2t4yo
from walk2gen4dev import set2u4yo
from walk2gen4dev import set2v4yo
from walk2gen4dev import set2w4yo
from walk2gen4dev import set2x4yo
from walk2gen4dev import set2y4yo
from walk2gen4dev import set2z4yo
from walk2gen4dev import set2contact4yo

from walk2gen4dev import set2cbo4yo
from walk2gen4dev import set2cco4yo
from walk2gen4dev import set2cdo4yo
from walk2gen4dev import set2ceo4yo
from walk2gen4dev import set2cfo4yo
from walk2gen4dev import set2cmo4yo
from walk2gen4dev import set2cpo4yo
from walk2gen4dev import set2cto4yo
from walk2gen4dev import set2sec4yo
from walk2gen4dev import set2venture4yo
from walk2gen4dev import set2legal4yo
from walk2gen4dev import set2endhtml4yo


from walk2gen4dev import set2kb4app


    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print-trace4xi" usage = "
# print XML trace
#"> 
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):
    
    class2print  = "walk2gen4tar"
    method2print = "walk2gen4tar" 
        
    message2print = "{passed" + "; t2xi-passed-to-print-trace4xi: " + str(t2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    #    

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
    context2sense = {
     'file_path4xi': '..//..//..//..//web//xml//sense-walk2gen4tar.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2gen4tar.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2gen4tar.owl#"\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing ofStudio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="yourDragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing walk2gen4tar.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">walk2gen4tar sensed.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..//..//..//..//web//xml//reason-walk2gen4tar.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2gen4tar.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2gen4tar.owl#"\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for walk2gen4tar.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..//..//..//..//web//xml//ace-walk2gen4tar.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2gen4tar.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2gen4tar.owl#"\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for walk2gen4tar.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of walk2gen4tar.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>

# JATKA       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "walk2gen4tar" usage = "
#   replaces defined targets from dragon4xi folders
#"> 
# -------------------------------------------------------------------------------------------------
def walk2gen4tar(target2explore):
    global ack2title
    global appdir2xi
    global app2xi
    
    global count2skipped
    global count2total
    
    global domain2xi
    global folder2xi
    global portal2xi
    global ack2debug
    
    global kb2app
    global kb2dev
    global kb2org
    global kb2com
    global kb2contact
    global kb2proxy
    global kb2portal
    global kb2slogan
    global kb2type
    global kb2time
    global kb2user
      
                              
    global keys2app
    global keys2dev
    global keys2org
    global keys2com
    global keys2contact  
    global keys2slogan  
    global keys2type
    global keys2time
    global keys2user
                          
    global key2app
    global key2dev
    global key2org
    global key2com 
    global key2slogan
    global key2type
    global key2time
    global key2user  
     
    global name2create
    global path2write4xi                           # path for output source targets
    global port2xi
    global profile2write                           # extension for files

    global t2xi
    global trace_object_count    
    
    class2print  = "walk2gen4tar"
    method2print = "walk2gen4tar" 
 
    message2print = "{(Step 0A1/33) using" + "; t2xi-using-by-walk2gen4tar: " + str(t2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)         
    # <print4xi.Print4Xi object at 0x0000000003715080>
    # 
    message2print = "{(Step 0A2/33) got" + "; target2explore-got-by-walk2gen4tar: " + str(target2explore)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    # G://temp//job2studio4xi//out//all2gen4tar//aero//
    
    # -----------------------------------------------------------------------------------------
    # (Step 4/33) OF WALK2GEN4TAR - GENERATE TAR SCRIPT TO BACKUP ALL APPS FOR ONE USER
    # -----------------------------------------------------------------------------------------
    path2output = target2explore
    
    message2print = "{(Step 4A/33) set" + "; path2output-set-by-walk2gen4tar to: " + str(path2output) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)     
    # G://temp//job2studio4xi//out//all2gen4tar//aero//
        
    kb2tar4apps = {}
    kb2tar4apps [0]  = '# backup ' + key2user + ' apps' + '\n'
    kb2tar4apps [1]  = '# ' + '\n'
    kb2tar4apps [2]  = 'cd /home/' + key2user + '/temp/backup' + ' && rm -f ' + key2user + '_apps_backup*' + ' && tar -czf /home/' + key2user + '/temp/backup/' + key2user + '_apps_backup$(/bin/date "+\%Y\%m\%d\%a\%T\%Z").tar.gz /home/' + key2user + '/' + 'apps > /dev/null 2>&1' + '\n'
    # cd /home/aero/temp/backup && rm -f aero_apps_backup* && tar -czf /home/aero/temp/backup/aero_apps_backup$(/bin/date "+\%Y\%m\%d\%a\%T\%Z").tar.gz /home/aero/apps > /dev/null 2>&1

    kb2tar4apps [3]  = 'ls' + '\n'
    kb2tar4apps [4]  = 'cd /home/' + key2user + '/temp/script' + '\n'
    kb2tar4apps [5]  = 'echo "done!"' + '\n'
    keys2tar4apps = kb2tar4apps.keys()

    path2output = path2output + 'tar2apps.sh'
                
    file2tar4apps = open(path2output,'w') 
    message2print = "{(Step 4B/33) opened" + "; file2tar4apps-opened-by-walk2gen4tar: " + str(file2tar4apps) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)     
    # <_io.TextIOWrapper name='G://temp//job2studio4xi//out//all2gen4tar//aero//tar2apps.sh' mode='w' encoding='cp1252'>           
            
    for key2tar4apps in keys2tar4apps:
    # 
        line2write = kb2tar4apps [key2tar4apps]   
        file2tar4apps.write(line2write)
        
    # # backup aero apps
    # # 
    # cd /home/aero/temp/backup && rm -f aero_apps_backup* && tar -czf /home/aero/temp/backup/aero_apps_backup$(/bin/date "+\%Y\%m\%d\%a\%T\%Z").tar.gz /home/aero/apps > /dev/null 2>&1
    # ls
    # cd /home/aero/temp/script
    # echo "done!"                
                
    # -----------------------------------------------------------------------------------------
    # (Step 5/33) OF WALK2GEN4TAR - CLOSE TAR SCRIPT TO BACKUP ALL APPS FOR ONE USER
    # -----------------------------------------------------------------------------------------            
    file2tar4apps.close()
    message2print = "{(Step 5A/33) closed" + "; file2tar4apps-closed-by-walk2gen4tar: " + str(file2tar4apps) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # <_io.TextIOWrapper name='G://temp//job2studio4xi//out//all2gen4tar//aero//tar2apps.sh' mode='w' encoding='cp1252'>
        

    # JATKA          
    # -------------------------------------------------------------------------------------------------
    # (Step 7/33) OF WALK2GEN4TAR - GENERATE TAR SCRIPT TO BACKUP USERSPACE-FPM-INSTALLER  FOR ONE USER
    # -------------------------------------------------------------------------------------------------
    path2output = target2explore
    
    message2print = "{(Step 7A/33) set" + "; path2output-set-by-walk2gen4tar to: " + str(path2output) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)     
    # G://temp//job2studio4xi//out//all2gen4tar//aero//
        
    kb2tar4apps = {}
    kb2tar4apps [0]  = '# backup ' + key2user + ' userspace-fpm-installer' + '\n'
    kb2tar4apps [1]  = '# ' + '\n'
    kb2tar4apps [2]  = 'cd /home/' + key2user + '/temp/backup' + ' && tar -czf /home/' + key2user + '/temp/backup/' + key2user + '_fpm_backup$(/bin/date "+\%Y\%m\%d\%a\%T\%Z").tar.gz /home/' + key2user + '/' + 'userspace-fpm-installer > /dev/null 2>&1' + '\n'
    kb2tar4apps [3]  = 'ls' + '\n'
    kb2tar4apps [4]  = 'cd /home/' + key2user + '/temp/script' + '\n'
    kb2tar4apps [5]  = 'echo "done!"' + '\n'
    keys2tar4apps = kb2tar4apps.keys()

    path2output = path2output + 'tar2fpm.sh'
                
    file2tar4userspacefpminstaller = open(path2output,'w') 
    message2print = "{(Step 7B/33) opened" + "; file2tar4userspacefpminstaller-opened-by-walk2gen4tar: " + str(file2tar4userspacefpminstaller) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)     
    # <_io.TextIOWrapper name='G://temp//job2studio4xi//out//all2gen4tar//aero//tar2fpm.sh' mode='w' encoding='cp1252'>          
            
    for key2tar4apps in keys2tar4apps:
    # 
        line2write = kb2tar4apps [key2tar4apps]   
        file2tar4userspacefpminstaller.write(line2write)           
                
    # # backup aero userspace-fpm-installer
    # # 
    # cd /home/aero/temp/backup && tar -czf /home/aero/temp/backup/aero_fpm_backup$(/bin/date "+\%Y\%m\%d\%a\%T\%Z").tar.gz /home/aero/userspace-fpm-installer > /dev/null 2>&1
    # ls
    # cd /home/aero/temp/script
    # echo "done!"        
        
        
        
    file2tar4userspacefpminstaller.close()
    message2print = "{(Step (7C/33) closed" + "; file2tar4userspacefpminstaller-closed-by-walk2gen4tar: " + str(file2tar4userspacefpminstaller) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # <_io.TextIOWrapper name='G://temp//job2studio4xi//out//all2gen4tar//aero//tar2fpm.sh' mode='w' encoding='cp1252'>
    
    
    # JATKA           
    # -------------------------------------------------------------------------------------------------
    # (Step 8/33) OF WALK2GEN4TAR - GENERATE SCRIPT CREATING CRON JOB FOR USER
    # -------------------------------------------------------------------------------------------------
    path2output = target2explore
    
    message2print = "{(Step 8A1/33) set" + "; path2output-set-by-walk2gen4tar to: " + str(path2output) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)     
    # G://temp//job2studio4xi//out//all2gen4tar//aero// 
        
    kb2job4apps = {}
    kb2job4apps [0]  = '# cronjob for ' + key2user  + '\n'
    kb2job4apps [1]  = '# backup every night ' + '\n'
    
    
    key2time = key2user
    message2print = "{(Step 8A2/33) set" + "; key2time-set-by-walk2gen4tar to: " + str(key2time) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)     
    # aero
    
    message2print = "{(Step 8A3/33) got" + "; keys2time-got-by-walk2gen4tar: " + str(keys2time) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)     
    # dict_keys(['appadmin', 'pacificocean', 'theater', 'indianocean', 'science', 'autonomous', 'aero', 'atlanticocean', 'business', 'devadmin', 'dragon', 'antarcticocean', 'arcticocean', 'relax', 'southernocean', 'intelligence'])
       
    
    if key2time in keys2time:
        kb2pick = kb2time[key2time]
        message2print = "{(Step 8A4/33) set" + "; kb2pick-set-by-walk2gen4tar to: " + str(kb2pick) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        # {0: '00 ', 1: '1 ', 2: '* ', 3: '* ', 4: '* '}
        
        min2start     = kb2pick [0] 
        hour2start    = kb2pick [1]
        day2start     = kb2pick [2]
        month2start   = kb2pick [3]
        weekday2start = kb2pick [4]
    else:
        key2time = "00 "
        message2print = "{(Step 8Z1/33) set" + "; key2time-set-by-walk2gen4tar to: " + str(key2time) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        # 
        min2start     = "00 "
        hour2start    = "3 "
        day2start     = "* "
        month2start   = "* "
        weekday2start = "* " 
    
                
    kb2job4apps [2]  = min2start + hour2start + day2start + month2start + weekday2start + 'cd /home/' + key2user + '/temp/backup' + ' && rm -f ' + key2user + '_apps_backup*' + ' && tar -czf /home/' + key2user + '/temp/backup/' + key2user + '_apps_backup$(/bin/date "+\%Y\%m\%d\%a\%T\%Z").tar.gz /home/' + key2user + '/' + 'apps > /dev/null 2>&1' + '\n'
    
    # JATKA 
    # -------------------------------------------------------------------------------------------------
    # Generate cron job line to start fpm process every 10 minutes in case it is dead 
    # -------------------------------------------------------------------------------------------------
    index2add = 3
    kb2cron = kb2user[key2user]
    keys2cron = kb2cron.keys()
    for keycron in keys2cron:
        if keycron > 0:
            if key2user == 'devadmin':
                kb2job4apps [index2add]  = '*/10 * * * * /home/' + key2user + '/apps/phpfpm' + '/bin/start > /dev/null 2>&1' + '\n'
                message2print = "{(Step 8A5/33) set" + "; kb2job4apps-set-by-walk2gen4tar-to : " + str(kb2job4apps [index2add]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)     
                # */10 * * * * /home/devadmin/apps/phpfpm/bin/start > /dev/null 2>&1 
            else:
                if key2user == 'appadmin':
                    kb2job4apps [index2add]  = '*/10 * * * * /home/' + key2user + '/apps/fpm2appadmin' + '/bin/start > /dev/null 2>&1' + '\n'
                    # 
                    message2print = "{(Step 8A6/33) set" + "; kb2job4apps-set-by-walk2gen4tar-to : " + str(kb2job4apps [index2add]) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)     
                    # */10 * * * * /home/appadmin/apps/fpm2appadmin/bin/start > /dev/null 2>&1
                else:
                    kb2job4apps [index2add]  = '*/10 * * * * /home/' + key2user + '/apps/fpm2' + kb2cron[keycron]  + '/bin/start > /dev/null 2>&1' + '\n' 
                    message2print = "{(Step 8A7/33) set" + "; kb2job4apps-set-by-walk2gen4tar-to : " + str(kb2job4apps [index2add]) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)     
                    # 
                    # aero
                    # */10 * * * * /home/aero/apps/fpm2jetport_app/bin/start > /dev/null 2>&1
                    # */10 * * * * /home/aero/apps/fpm2jetport_dev/bin/start > /dev/null 2>&1
                    # ...
                    # */10 * * * * /home/antarcticocean/apps/fpm2antarcticocean_app/bin/start > /dev/null 2>&1
                    # ...
                    
            index2add = index2add + 1      
        else:
            pass
            
    keys2job4apps = kb2job4apps.keys()

    path2output = path2output + 'job2cron.sh'
                
    file2job4cron = open(path2output,'w') 
    message2print = "{(Step 8B/33) opened" + "; file2job4cron-opened-by-walk2gen4tar: " + str(file2job4cron) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)     
    # <_io.TextIOWrapper name='G://temp//job2studio4xi//out//all2gen4tar//aero//job2cron.sh' mode='w' encoding='cp1252'>             
            
    for key2job4apps in keys2job4apps:
    # 
        line2write = kb2job4apps [key2job4apps]   
        file2job4cron.write(line2write)           
        
    file2job4cron.close()
    message2print = "{(Step (8C/33) closed" + "; file2job4cron-closed-by-walk2gen4tar: " + str(file2job4cron) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # <_io.TextIOWrapper name='G://temp//job2studio4xi//out//all2gen4tar//aero//job2cron.sh' mode='w' encoding='cp1252'>     
        
    # JATKA           
    # -------------------------------------------------------------------------------------------------
    # (Step 9/33) OF WALK2GEN4TAR - GENERATE STEPS TO CRON FOR USER
    # -------------------------------------------------------------------------------------------------
    path2output = target2explore
    
    message2print = "{(Step 9A/33) set" + "; path2output-set-by-walk2gen4tar to: " + str(path2output) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)     
    # G://temp//job2studio4xi//out//all2gen4tar//aero//
        
    kb2steps4cron = {}
    kb2steps4cron [0]  = '# crontab -l' + '\n'
    kb2steps4cron [1]  = '# crontab -r' + '\n'
    kb2steps4cron [2]  = 'crontab job2cron.sh' + '.sh' + '\n'
    kb2steps4cron [3]  = '# crontab -l' + '\n'
    keys2job4apps = kb2steps4cron.keys()

    path2output = path2output + 'steps2cron.txt'
                
    file2steps4cron = open(path2output,'w') 
    message2print = "{(Step 9B/33) opened" + "; file2steps4cron-opened-by-walk2gen4tar: " + str(file2steps4cron) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)     
    # <_io.TextIOWrapper name='G://temp//job2studio4xi//out//all2gen4tar//aero//steps2cron.txt' mode='w' encoding='cp1252'>            
            
    for key2job4apps in keys2job4apps:
    # 
        line2write = kb2steps4cron [key2job4apps]   
        file2steps4cron.write(line2write)           
    
    # # crontab -l
    # # crontab -r
    # crontab job2cron.sh.sh
    # # crontab -l    
            
    file2job4cron.close()
    message2print = "{(Step (9C/33) closed" + "; file2steps4cron-closed-by-walk2gen4tar: " + str(file2steps4cron) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # <_io.TextIOWrapper name='G://temp//job2studio4xi//out//all2gen4tar//aero//steps2cron.txt' mode='w' encoding='cp1252'>

             
    
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   reviewing all tests
#">                           
# -------------------------------------------------------------------------------------------------
def main():
    global ack2debug
    global appdir2xi
    global app2xi
    
    global count2skipped
    global count2total
   
    global domain2xi
    
    global folder2xi
    
    global portal2xi
    global port2xi
    
    global kb2app
    global kb2portal
    global kb2proxy
    global kb2proxy
    global kb2type
    global kb2user
    
    global keys2type
    global keys2user
    
    global key2user
    global path2write4xi
    global profile2write

    global t2xi
    global trace_object_count    

       
                       
    # ------------------------------------------------------------------------------------------------- 
    # INITIALIZE
    # -------------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    if ack2debug is True:
        print("(Step 0A/33) OF MAIN WALK2GEN4TAR - SET T2XI TO: ", t2xi)
        # <print4xi.Print4Xi  at 0x0000000003715080> 
    
     
    count2skipped = 0
    count2replaced = 0
    count2total  = 0   

    set2trace4replace()                                                                                             # trace all classes and functions in the system
    deny2trace4replace()                                                                                            # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                               # tailor trace for this test    

    pipe2fetch = Pipe4Xi()
    queue2fetch = Queue4Xi()
    
    # --------------------------------------------------------------------------------------------- 
    # START
    # ---------------------------------------------------------------------------------------------        
    print('=' *70)
    print("(Step 0B/33) OF MAIN WALK2GEN4TAR - VERSION 2.11 STARTED ", time4xi())
    # VERSION 2.11 STARTED  15:41:21 11/19/24 FLE Standard Time
    
    pipe2fetch = Pipe4Xi()
    if ack2debug is True:
        print("(Step 1A/33) OF MAIN WALK2GEN4TAR - PIPE2FETCH ", pipe2fetch)    
        # (<pipeconnection4xi.PipeConnection4Xi object at 0x0000000002531860>, <pipeconnection4xi.PipeConnection4Xi object at 0x0000000002531908>)
    
    queue2fetch = Queue4Xi()
    if ack2debug is True:
        print("(Step 1B/33) OF MAIN WALK2GEN4TAR - QUEUE2FETCH ", queue2fetch)    
        # <queue4xi.Queue4Xi object at 0x0000000002531400>
        
        print("(Step 1D/33) OF MAIN WALK2GEN4TAR - PATH2WRITE4XI ", path2write4xi)
        # (Step 1D/33) OF MAIN WALK2GEN4TAR - PATH2WRITE4XI
    
    # JATKA    
    for dir2walk in DirectoryWalker(path2write4xi):
        # ----------------------------------------------------------------------------------------- 
        # aero ... theater
        # -----------------------------------------------------------------------------------------     
        if os.path.isdir(dir2walk):
            print("(Step 2A/33) OF MAIN WALK2GEN4TAR - VPS USER DIRECTORY: ", dir2walk)
            # H://temp//job2studio4xi//out//all2gen4tar//aero
            # ..
            # H://temp//job2studio4xi//out//all2gen4tar//theater
            
            # -----------------------------------------------------------------------------------------
            # (Step 2B/33) OF WALK2REPLACE4APP - VPS USER FOLDER 
            # -----------------------------------------------------------------------------------------
            string2skip = '/'
            folder2xi = dir2walk
            max2try = 33
            count2try = 0
            while 1:
                index2skip = str.find(folder2xi,string2skip)
                count2try = count2try + 1
                if (index2skip == -1) or (count2try > max2try):
                    break
                else:
                    folder2xi = folder2xi[index2skip+1:]
         
            print("(Step 2C/33) OF MAIN WALK2GEN4TAR - FOLDER2XI: ", folder2xi)
            # aero antarcticocean appadmin arcticocean atlanticocean autonomous business devadmin dragon indianocean
            # intelligence pacificocean relax science southernocean theater 

            key2user = folder2xi
            # 
            if key2user in keys2user:
                print("(Step 2D/33) OF MAIN WALK2GEN4TAR - KEY2USER: ", key2user)
                # 'aero' ... 'theater'
                
                path2write4tar = path2write4xi + key2user  + '//'
                print("(Step 2E/33) OF MAIN WALK2GEN4TAR - path2write4xi: ", path2write4tar)
                # G://temp//job2studio4xi//out//all2gen4tar//aero// 
                
                walk2gen4tar(path2write4tar)

            else:

                print("(Step 2Z5/33) OF MAIN WALK2GEN4TAR - ** ERROR: KEY2USER: ", key2user)    
                # 
                print("(Step 2Z6/33) OF MAIN WALK2GEN4TAR - ** ERROR KEY2USER NOT IN KEYS2USER: ", keys2user)
                #
                break                
        

                
    # --------------------------------------------------------------------------------------------- 
    # END
    # --------------------------------------------------------------------------------------------- 
    print('=' *75)
    print("(Step 33A/33) OF MAIN WALK2GEN4TAR - VERSION 4.4 - OUT: ", path2write4xi," - PROFILE: ", profile2write, " COMPLETED  ", time4xi())
    # 
    # 
     
    # ---------------------------------------------------------------------------------------------    
    # Print Trace
    # ---------------------------------------------------------------------------------------------     
    # print ('(Step 1E/33) OF MAIN WALK2GEN4TAR - PRINTING TRACE WITH T2XI', t2xi)
    # 
    # print_trace4xi(t2xi)        
    # print ('(Step 1F/33) OF MAIN WALK2GEN4TAR - PRINTED TRACE WITH T2XI', t2xi)           
    
#</function4xi>
    
        
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()        
#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "

# ftp upload
# E:\DRAGONXI\OpalStack\users\aero\temp\script\job2cron.sh
# E:\DRAGONXI\OpalStack\users\aero\temp\script\tar2apps.sh
# E:\DRAGONXI\OpalStack\users\aero\temp\script\tar2fpm.sh
# E:\DRAGONXI\OpalStack\users\aero\temp\script\steps2cron.txt
# ...

# generated by walk2gen4tar.py
# G:\temp\job2studio4xi\out\all2gen4tar\aero\job2cron.sh
# G:\temp\job2studio4xi\out\all2gen4tar\aero\tar2apps.sh
# G:\temp\job2studio4xi\out\all2gen4tar\aero\tar2fpm.sh
# G:\temp\job2studio4xi\out\all2gen4tar\aero\steps2cron.txt
# ...

# ftp dowloaded
# E:\DRAGONXI\OpalStack\users\aero\temp\backup\aero_apps_backup_2021_04_13_Tue_08_30_24_UTC.tar.gz
# E:\DRAGONXI\OpalStack\users\aero\temp\backup\aero_fpm_backup_2021_04_13_Tue_08_26_59_UTC.tar.gz

# web sites
# https://www.jetport.app/
# https://www.jetport.dev/
# ...

#"
#>
#     
# 
# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of walk2gen4tar.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

